;;; Menubar for Visual Logo
;;; Albert Castillo May, 1995


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Setup Menubar

(defvar *user-menubar* (menubar))

(defparameter *logobar*
  (list (car *default-menubar*)
        (make-instance 'menu
                       :menu-title "File"
                       :menu-items
                       (list (make-instance 'menu-item
                               :menu-item-title "New Logo Window"
                               :menu-item-action #'(lambda nil (make-interface))
                               :command-key #\N)
                             (make-instance 'menu-item
                               :menu-item-title "Open..."
                               :disabled t
                               :menu-item-action
                               'choose-file-dialog
                               :command-key #\O)
                             (make-instance 'menu-item
                               :menu-item-title "-"
                               :disabled t)
                             (make-instance 'menu-item
                               :menu-item-title "Close"
                               :menu-item-action
                               #'(lambda nil (window-close *main*))
                               :command-key #\W)
                             (make-instance 'menu-item
                               :menu-item-title "Save"
                               :disabled t
                               :command-key #\S
                               :menu-item-action 'window-save)
                             (make-instance 'menu-item
                               :menu-item-title "Save As..."
                               :disabled t
                               :menu-item-action 'window-save-as)
                             (make-instance 'menu-item
                               :menu-item-title "-"
                               :disabled t)
                             (make-instance 'menu-item
                               :menu-item-title "Quit"
                               :menu-item-action
                               'quit)))
        (make-instance 'menu
                       :menu-title "Edit"
                       :menu-items
                       (list (make-instance 'menu-item
                                            :menu-item-title "Undo"
                                            :disabled t
                                            :command-key #\Z
                                            :menu-item-action 'undo)
                             (make-instance 'menu-item
                                            :menu-item-title "-"
                                            :disabled t)
                             (make-instance 'window-menu-item
                                            :menu-item-title "Cut"
                                            :command-key #\X
                                            :menu-item-action 'cut)
                             (make-instance 'window-menu-item
                                            :menu-item-title "Copy"
                                            :command-key #\C
                                            :menu-item-action 'copy)
                             (make-instance 'window-menu-item
                                            :menu-item-title "Paste"
                                            :command-key #\V
                                            :menu-item-action 'paste)
                             (make-instance 'window-menu-item
                                            :menu-item-title "Clear"
                                            :menu-item-action 'clear)
                             (make-instance 'menu-item
                                            :menu-item-title "-"
                                            :disabled t)
                             (make-instance 'menu-item
                                            :menu-item-title "Clear screen"
                                            :menu-item-action #'(lambda ()
                                                                  (delete-all-objects *main*)))
                             (make-instance 'menu-item
                                            :menu-item-title "-"
                                            :disabled t)
                             (make-instance 'menu-item
                                            :menu-item-title "MCL Menubar"
                                            :menu-item-action #'(lambda ()
                                                                  (set-menubar *user-menubar*)))))
        (make-instance 'menu
                       :menu-title "Eval"
                       :menu-items
                       (list (make-instance 'menu-item
                               :menu-item-title "Download! (multi-block)"
                               :menu-item-action
                               #'(lambda nil
                                   (generate-code1 *main*)))
                             (make-instance 'menu-item
                               :menu-item-title "Debug Brick Code (multi-block)"
                               :menu-item-action
                               #'(lambda nil
                                   (select-item-from-list (debug-code1 *main*)
                                                          :window-title "Brick Code (multi-blocks)")))
                                                          
                             (make-instance 'menu-item
                                            :menu-item-title "-"
                                            :disabled t)

                             (make-instance 'menu-item
                               :menu-item-title "Download! (old)"
                               :menu-item-action 
                               #'(lambda nil
                                   (generate-code *main*)))
                             (make-instance 'menu-item
                               :menu-item-title "Debug Brick Code (old)"
                               :menu-item-action 
                               #'(lambda nil
                                   (select-item-from-list (debug-code *main*)
                                                          :window-title "Brick Code")))
                             ))
        (make-instance 'menu
          :menu-title "Help"
          :menu-items
          (list (make-instance 'menu-item
                  :menu-item-title "About"
                  :menu-item-action
                  #'(lambda nil
                      (message-dialog "Visual Logo        Ver. 0")))))))


;;; Load the new menubar and GO!
;;; Choose "New Logo Window" from File menu                            
;(set-menubar *logobar*)

(defun menu () (set-menubar *logobar*))